import { VariantLabels } from "../motion/types";
import { VisualElement } from "../render/VisualElement";
/**
 * Handle variants and the `animate` prop when its set as variant labels.
 *
 * @param initial - Initial variant(s)
 * @param animate - Variant(s) to animate to
 * @param inherit - `true` is inheriting animations from parent
 * @param controls - Animation controls
 *
 * @internal
 */
export declare function useVariantAnimations(visualElement: VisualElement, initial: VariantLabels, animate: VariantLabels, inherit: boolean): void;
